class Player {
  float posX, posY, movX, movY, speedY;
  int id, size, thickness, score, type;
  int difficulty, pause, pauseTime, movPause, dir;
  float currSpeed;
  float top;
  float bot;
  float left;
  float right;
  color rectColor;

  Player(int _id, float _posX, float _posY, int _type) {
    id = _id;
    posX = _posX;
    posY = _posY;
    type = _type;
    size = 80;
    thickness = 10;
    score = 0;
    pause = 75;
    pauseTime = pause;
    movPause = 0;
    dir = 0;
    currSpeed = 3;
    rectColor = color(255);
  }

  void draw() {
    update();
    noStroke();
   
    fill(rectColor);
    rect(posX, posY, thickness, size);

    posY += speedY;
    //checks to see if the paddle is out of bounds
    if (posY < padding+size/2) {
        posY = padding+size/2;
    } else if (posY > height-padding-size/2) {
       posY = height-padding-size/2;
    }
    
  }

  void update() {
   // get paddle edges
   top    = posY - size/2;
   bot    = posY + size/2;
   left   = posX - thickness/2;
   right  = posX + thickness/2;
   currSpeed = map(size,0, 80, 10, 3);
  }
  
  void up() {
    speedY = currSpeed;
    speedY = speedY * -1;
    movY = movY * -1;
  }

  void down() {
    speedY = currSpeed;
    speedY = speedY * 1;
    movY = movY * 1;
  }

  void stop() {
    speedY = 0;
  }


  float getMovY() {
    return movY;
  }

  void scorePlus() {
    if(start){ 
      score ++;
    }
  }

  int getScore() {
    return score;
  }

  void resetScore() {
    score = 0;
  }

  void setPos(int _posX, int _posY) {
    posX = _posX;
    posY = _posY;
  }
  
  void reset(){
    size = 80;
  }
}

