//PING is a prototype made for Intro to Game Design: LiveLessions
//It is open source under a Creative Commons 4.0 Attribution-ShareAlike License (https://creativecommons.org/licenses/by-sa/4.0/legalcode)

//import sound
import ddf.minim.*;
Minim minim;
AudioSample kick;

//Here's where we initiate all of the main objects in the game; note that they have their own code files
Ground ground;
Player player1;
Player player2;
Ball ball;

boolean start = false;
int padding = 25;
PFont scoreFont;

//setup is a function that we contain all of the initial states of the game in
void setup() {
   //sound 
  minim = new Minim(this);
  kick = minim.loadSample( "18791.mp3", // filename
                  512      // buffer size
                         );
  
  //-----
  size(640, 480);
  ground = new Ground();
  player1 = new Player(1, 20, height/2, 1);
  player2 = new Player(2, width - 20, height/2, 1);
  player1.stop();
  player2.stop();
  ball = new Ball(0, 0);
  ball.setPos(width/2, height/2);
  scoreFont = createFont("Arial", 40);
  textFont(scoreFont);
}

//draw is another processing function where anything happening on the screen is drawn and updated
void draw() {
  background(0);
  stroke(255); 
  fill(255);
  ground.draw();
  player1.draw();
  player2.draw();
  ball.draw();
  if (start) {
    
  }else{
   fill(255);
   textAlign(CENTER);
   textSize(64);
   text("PING",width/2,height/2-32);
   textSize(14);
   text("Player 1: 'W' move up, 'S' move down, 'Q' change paddle",width/2,height/2+32);
   text("Player 2:  Narrow Key 'UP' move up, narrow Key'DOWN' move down, '/' change paddle",width/2,height/2+64);
   
   textSize(22);
   text("Press 'SPACE' to Start",width/2,height/2+100);
  }
   

}

void keyPressed() {
  if (key == 'w' || key == 'W') {
    player1.up();
  }
  if (key == 's' || key == 'S') {
    player1.down();
  }
  
  if (keyCode == UP) {
    player2.up();
  }
  if (keyCode == DOWN) {
    player2.down();
  }
  
  if (key == ' '){
    if(start == false){
        ball.reset();
        player1.reset();
        player2.reset();
        start = true;
    }
  }
}

void keyReleased() {
  if (key == 'w' || key == 'W' || key == 's' || key == 'S') {
    player1.stop();
  } else if (keyCode == UP || keyCode == DOWN) {
    player2.stop();
  }
}

void resetGame() {
  player1.setPos(20, height/2);
  player2.setPos(width - 20, height/2);
  player1.resetScore();
  player2.resetScore();
    ball.posX =  width/2;
    ball.posY = height/2;
    ball.movY = 0;
}

