class Ball {

  float posX, posY,orgX,orgY, movX, movY, speedX, speedY, size;
 
  float ballLeft;
  float ballRight;
  float ballTop;
  float ballBot;

  Ball(float _posX, float _posY) {
    posX = _posX;
    posY = _posY;
    movX = 3;
    movY = 0;
    speedX = 0;
    speedY = 0;
    size = 10;
   }

  void setPos(float _posX, float _posY) {
    posX = _posX;
    posY = _posY;
    orgX = posX;
    orgY = posY;
  }

  void update() {
    posX += movX;
    posY += movY;
   
    //calculate ball edges
    ballLeft = posX-size/2;
    ballRight = posX+size/2;
    ballTop = posY - size/2;
    ballBot = posY + size/2;
    
    //detect boundary 
    checkBoundry();
    
    //left paddel interaction
    if(ballLeft< player1.right && ballRight > player1.left){
      if(ballBot > player1.top && ballTop < player1.bot){
        movX *=-1;
        posX = player1.right + size/2;
        float hit = posY - player1.posY;
        movY += (hit / (player1.size/2)) *2;    
      //reduce the paddle 1 size
        player1.size -=2;
         if(player1.size<10){
          player1.size = 10;
        }
        //play sound
        kick.trigger();
      }
    }
    
     //right paddel interaction
    if(ballRight > player2.left && ballLeft < player2.right){
      if(ballBot > player2.top && ballTop < player2.bot){
        movX *=-1;
        posX = player2.left - size/2;
        float hit = posY - player2.posY;
        movY += (hit / (player2.size/2)) *2; // range -1 to 1 (*2)
        //reduce the paddle 2 size
        player2.size -=2;
        if(player2.size<10){
          player2.size = 10;
        }
        //play sound
        kick.trigger();
      }
    }
    
   }
  
  // reset ball's position
  void reset(){
     posX = orgX;
     posY = orgY;
     movX = 0;
     movY = 0;
     
     //we use random to change ball's initial direction
     //ball's initial speed
     int speed = 5;
     if(random(100)>50){
        movX = speed;
     }else{
        movX = -speed;
     }
     
  }

  float getPosY() {
    return posY;
  }
  
  void draw() {
    update();
    rectMode(CENTER);
    noStroke();
    fill(255);
    rect(posX, posY, size, size);
  }
  
  void checkBoundry(){
    
    if ( ballTop < padding ){ // check top side
       posY = padding + size/2;
       movY *= -1;
       kick.trigger();
    }
  
    if(ballBot > height-padding ) {  // check bottom side
      movY *= -1;
      posY = height - padding - size/2;
      kick.trigger();
    }
    
    if (posX < 0) { // out left side
       player2.scorePlus();
        player2.size*=2; 
       if(player2.size>80){
          player2.size = 80;
        }  
       reset();
    }
    
     if (posX > width + size/2) { // out right side
       player1.scorePlus(); 
       player1.size*=2; 
       if(player1.size>80){
          player1.size = 80;
        }      
       reset();
    }
  }
}




